IMPLEMENTATION MODULE Jugador;

FROM Storage IMPORT Available,ALLOCATE,DEALLOCATE;

TYPE
	
	Nave=RECORD
				x:CARDINAL;
				disparo:BOOLEAN;
			END;
	
	
	TipoJugador=POINTER TO Nave;
	

PROCEDURE CrearJugador():TipoJugador;
(* ESTA FUNCION SOLO CREA UN JUGADOR  *)

VAR
	jugador:TipoJugador;
BEGIN
	IF Available(SIZE(Nave)) THEN
		NEW(jugador);
		jugador^.x:=10;
		jugador^.disparo:=FALSE;
	END;
	RETURN jugador;
END CrearJugador;
	

PROCEDURE Destruido(jug:TipoJugador;serpix,serpiy,tiroserx,tirosery:CARDINAL):BOOLEAN;
(* ESTA FUNCION NOS COMPRUEBA SI NUESTRA NAVE HA SIDO ALCANZADA CON UN
PROYECTIL O CON LA SERPIENTE *)

VAR
	x,y:CARDINAL;
BEGIN
   y:=23;
   x:=jug^.x;
   IF (((x=serpix) AND (y=serpiy)) OR ((x=tiroserx) AND (y=tirosery))) THEN
   	RETURN TRUE;
   ELSE
   	RETURN FALSE;
   END;
END Destruido;

PROCEDURE EstaDisparando(jug:TipoJugador):BOOLEAN;
(* DEVUELVE EL ESTADO DEL DISPARADOR DE LA NAVE *)
BEGIN
	RETURN jug^.disparo
END EstaDisparando;

PROCEDURE MoverDerecha(VAR jugador:TipoJugador);
(* MUEVE LA NAVE A LA DERECHA PERO CON PANTALLA REDONDA *)
BEGIN
	IF jugador^.x=29 THEN
		jugador^.x:=2;
	ELSE
		jugador^.x:=jugador^.x+1;
	END;
END MoverDerecha;

PROCEDURE MoverIzquierda(VAR jugador:TipoJugador);
(* MUEVE LA NAVE A LA IZQUIERDA CON PANTALLA REDONDA *)
BEGIN
	IF jugador^.x=2 THEN
		jugador^.x:=29;
	ELSE
		jugador^.x:=jugador^.x-1;
	END;
END MoverIzquierda;

PROCEDURE Disparar(VAR jugador:TipoJugador);
(* ACTIVAMOS EL DISPARADOR DE LA NAVE*)
BEGIN
	jugador^.disparo:=TRUE;

END Disparar;

PROCEDURE ImprimirJugador(jugador:TipoJugador):CARDINAL;
(* NOS DEVUELVE LA POSICION DEL JUGADOR EN EL EJE X *)
BEGIN
	RETURN jugador^.x;
END ImprimirJugador;	


PROCEDURE DesbloquearDisparo(jug:TipoJugador);
(* DESBLOQUEA EL DISPARADOR DE LA NAVE *)
BEGIN
	jug^.disparo:=FALSE;
END DesbloquearDisparo;

PROCEDURE DestruirJugador(VAR jugador:TipoJugador);
(* LIBERA LA MEMORIA USADA POR LA NAVE *)
BEGIN
	DISPOSE(jugador);
END DestruirJugador;

END Jugador.
				